#ifndef REQ_H
#define REQ_H 1

#ifndef INTUITION_INTUITION_H
#include <intuition/intuition.h>
#endif

#define FILEREQ_ERROR ((short)-1)
#define CANCEL ((short)2)
#define OKAY ((short)1)
#define NUM_COLORS 4L

#define REGS register

typedef  void (*PFV)();

typedef struct
{
struct Screen *screen;
UBYTE *path;
UBYTE *file;
UBYTE *heading;
UBYTE *buf;
long bufsize;
long n_entries;
UWORD flags;
ULONG user_signals;
PFV user_func;
} FileReq;

/* Flag bits */
#define CLI_BIT (1<<0)            /* you set if run from CLI */
#define NATURAL_COLOR_BIT (1<<1)  /* you set if you want natural colors */

#endif
